diff -r 0319240072d8 buildsys.mk
--- a/buildsys.mk.orig	2012-12-20 11:40:45.442431988 +0100
+++ b/buildsys.mk	2012-12-20 11:12:26.446433852 +0100
@@ -38,3 +38,3 @@
 ASFLAGS = @ASFLAGS@
-CFLAGS = -g -O2
+CFLAGS = -g -O2 -DDOVECOT_BINARY_VERSION=${DOVECOT_BINARY_VERSION}
 CXXFLAGS = @CXXFLAGS@
diff -r 0319240072d8 extra.mk
--- a/extra.mk.orig	2012-12-20 11:40:05.410460667 +0100
+++ b/extra.mk	2012-12-20 11:12:27.119434753 +0100
@@ -9 +9,4 @@
 DOVECOT_MODULE_DIR = /usr/local/dovecot-2.1.12/lib/dovecot
+
+# version 2.1.12
+DOVECOT_BINARY_VERSION = 2001
diff -r 0319240072d8 src/signature-log.c
--- a/src/signature-log.c	Thu Dec 20 03:56:26 2012 +0200
+++ b/src/signature-log.c	Thu Dec 20 11:42:15 2012 +0100
@@ -118,8 +118,16 @@
     if (sltc == NULL)
 	return NULL;
 
+#if DOVECOT_BINARY_VERSION >= 2002
     if (dict_init(cfg->dict_uri, DICT_DATA_TYPE_STRING, cfg->dict_user,
 		cfg->base_dir, &sltc->dict, NULL))
+#else
+    sltc->dict =
+           dict_init(cfg->dict_uri, DICT_DATA_TYPE_STRING, cfg->dict_user,
+           cfg->base_dir);
+
+    if (sltc->dict == NULL)
+#endif
     {
 	i_free(sltc);
 	return NULL;
